#!/bin/sh

PERMISSION_FILE=/etc/permission
#------------------------
#help Message
#------------------------
usage()
{
	echo "	Usage:			"
	echo "	Arg 1: host or target 	"
	echo "	Arg 2: root fs diretory path"
	echo "	Arg 3: path of folder where system user data present or path of ftp base folder of system"
	echo "	Arg 4: path of folder where system user data present or path of ftp base folder of system"
	echo "	Maximum 2 differen path are allow to store user data "
	echo "	Example in VOIP card ftp base folder is /matrix"
}


#Check argument count
if [ $# -lt 1 ] 
then
	usage
	exit 1
fi

if [ $# -gt 4 ] 
then
	usage
	exit 1
fi

#update the variable with user input
RUN_ON=$1
ROOTFS_LOC=$2
data_path1=$3
data_path2=$4


#on target script should be run one time only
# To achieve this create the permission file /etc folder when script end. 
# So before doing any change it check the file present the script will exit whiout changing permission.
if [ "$RUN_ON" == "target" ]
then
	if [ -f $PERMISSION_FILE ]
	then
		exit
	fi
fi

echo "change the root fs permission"

chown -R -h root:root $ROOTFS_LOC/* >& /dev/null
chown -h root:root $ROOTFS_LOC/linuxrc >& /dev/null

#Please Add product specific folder which are part of root fs and not listed hear.

#try to get the userid and groupid for se user from the rootfs /etc/passwd file 
if [ "$RUN_ON" == "host" ]
then

	seusernotfound=0
	while read line
	do
		username=`echo $line | awk -F ":" '{ print $1 }'`
		if [ "se" == "$username" ]
		then
			userid=`echo $line | awk -F ":" '{ print $3 }'`
			groupid=`echo $line | awk -F ":" '{ print $4 }'`
		
			echo "user name $username"
			echo "user id $userid"
			echo "group id $groupid"
			seusernotfound=1
		fi
	done < $ROOTFS_LOC/etc/passwd

	if [ $seusernotfound -eq 0 ]
	then
		echo "se user not found from the $PASSWDFILE"
		exit
	fi
fi


#change the user data folder and file owner and group to se
if [ "$RUN_ON" == "host" ]
then
	hostinfo=`stat -c "%U:%G" $data_path1`
	chown -R --from=$hostinfo $userid:$groupid $data_path1
	chown -R -h --from=$hostinfo $userid:$groupid $data_path1/* #set se uer permission if directoy accessable from ftp. This may change as per product ftp base directory
elif [ "$RUN_ON" == "target" ]
then
	chown se:se $data_path1
	chown -R -h se:se $data_path1/* #set se uer permission if directoy accessable from ftp. This may change as per product ftp base directory
fi


#change the user data folder and file owner and group to se
if [ $# -eq 4 ]
then

	if [ "$RUN_ON" == "host" ]
	then
		hostinfo=`stat -c "%U:%G" $data_path2`
		chown -R --from=$hostinfo $userid:$groupid $data_path2
		chown -R -h --from=$hostinfo $userid:$groupid $data_path2/* #set se uer permission if directoy accessable from ftp. This may change as per product ftp base directory
	elif [ "$RUN_ON" == "target" ]
	then
		chown se:se $data_path2
		chown -R -h se:se $data_path2/* #set se uer permission if directoy accessable from ftp. This may change as per product ftp base directory
	fi

fi


#permission meaning
# only user have read and write permission which group and other user can read and execute only.
#user/owner 	group	other
#rwx		rwx	rwx
#111		101	101
#7		5	5

#please readn man page of chown and chmod for more information

#change permission of all folder and file of root fs
chmod -R 755 $ROOTFS_LOC/* >& /dev/null
# set the SUID bit of busybox so all command will run by se user
chmod u+s $ROOTFS_LOC/bin/busybox 

#to verify please run below command
#ls -al /bin/* (Please see below line is out of command ls -al)

# file permission	owner	group		Date		filename
# rwsr_xr_x	    1 	root  	root             7 Dec  3 05:54 busybox

#ls -as/matrix/*
# rwsr_xr_x	    1 	se  	se             7 Dec  3 05:54 appl

echo "done" > $ROOTFS_LOC/$PERMISSION_FILE

