#!/bin/sh

file="uart.ko"
module="uart"
device="uart"

case "$1" in
  start)
    #echo 'Starting Matrix watchdog Module'

    if [ -e /dev/${device} ]; then
      rm -f /dev/${device}*
    fi
    insmod $file $2 $3 $4 $5 $6 $7 || exit 1
    for i in `grep $device /proc/devices` ; do
       if [ $i != $device ]; then
          major=$i
       fi
    done
    #echo 'Major Number : ' $major
    mknod /dev/${device} c $major 0
    ;;
  stop)
    echo 'Stopping Matrix uart Driver'

    if [ -e /dev/${device} ]; then
      rm -f /dev/${device}*
    fi
    rmmod $module
    ;;
  restart)
    $0 stop
    $0 start
    ;;
  *)
    echo "Usage: $0 {start|stop|restart}"
    exit 1
    ;;
esac

exit 0
